//+------------------------------------------------------------------+
//|                                             Steop stochastic.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DimGray
#property indicator_color2  PaleVioletRed
#property indicator_width2  2
#property indicator_minimum -1
#property indicator_maximum 101

//
//
//
//
//

extern int    UsePrice   = PRICE_CLOSE;
extern int    ATR_Length = 10;
extern double K_Slow     =  1;
extern double K_Fast     =  1;
extern int    Window     = 256;

//
//
//
//
//

double stoch1[];
double stoch2[];
double atr[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,stoch2);
   SetIndexBuffer(1,stoch1);
   SetIndexBuffer(2,atr);
      IndicatorShortName("Step stochastic )"+ATR_Length+","+DoubleToStr(K_Slow,2)+","+DoubleToStr(K_Fast,2)+","+Window+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][12];
#define k_SminMin   0
#define k_SmaxMin   1
#define k_SminMid   2
#define k_SmaxMid   3
#define k_SminMax   4
#define k_SmaxMax   5
#define k_TrendMin  6
#define k_TrendMid  7
#define k_TrendMax  8
#define k_linemin   9 
#define k_linemid  10
#define k_linemax  11
#define bigValue   99999999

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      double nPrice = iMA(NULL,0,1,0,MODE_SMA,UsePrice,i);  
             atr[i] = iATR(NULL,0,ATR_Length,i);
             if (r<=Window)
             {
                  work[r][k_TrendMin] = 0;
                  work[r][k_TrendMid] = 0;
                  work[r][k_TrendMax] = 0;
                  work[r][k_linemin]  = 0;
                  work[r][k_linemid]  = 0;
                  work[r][k_linemax]  = 0;
                  work[r][k_SminMin]  = bigValue;
                  work[r][k_SmaxMin]  = bigValue;
                  work[r][k_SminMax]  = 0;
                  work[r][k_SmaxMax]  = 0;
                  work[r][k_SminMid]  = 0;
                  work[r][k_SmaxMid]  = 0;
                  continue;
             }

      //
      //
      //
      //
      //
      
         double nATRmax     = atr[ArrayMaximum(atr,Window,i)];
         double nATRmin     = atr[ArrayMinimum(atr,Window,i)];
         double StepSizeMin = (K_Fast * nATRmin);
         double StepSizeMax = (K_Fast * nATRmax);
         double StepSizeMid = (K_Fast * 0.5 * K_Slow * (nATRmax + nATRmin));

            work[r][k_SmaxMin] = nPrice + 2.0 * StepSizeMin;
            work[r][k_SminMin] = nPrice - 2.0 * StepSizeMin;
            work[r][k_SmaxMax] = nPrice + 2.0 * StepSizeMax;
            work[r][k_SminMax] = nPrice - 2.0 * StepSizeMax;
            work[r][k_SmaxMid] = nPrice + 2.0 * StepSizeMid;
            work[r][k_SminMid] = nPrice - 2.0 * StepSizeMid;

            //
            //
            //
            //
            //
         
            double TrendMin = work[r-1][k_TrendMin];
            double TrendMid = work[r-1][k_TrendMid];
            double TrendMax = work[r-1][k_TrendMax];
            double linemin  = work[r-1][k_linemin];
            double linemid  = work[r-1][k_linemid];
            double linemax  = work[r-1][k_linemax];

            //
            //
            //
            //
            //
                        
            if (nPrice > work[r-1][k_SmaxMin]) TrendMin =  1;
            if (nPrice < work[r-1][k_SminMin]) TrendMin = -1;
            if (nPrice > work[r-1][k_SmaxMax]) TrendMax =  1;
            if (nPrice < work[r-1][k_SminMax]) TrendMax = -1;
            if (nPrice > work[r-1][k_SmaxMid]) TrendMid =  1;
            if (nPrice < work[r-1][k_SminMid]) TrendMid = -1;

            if (TrendMin > 0 && work[r][k_SminMin] < work[r-1][k_SminMin]) work[r][k_SminMin] = work[r-1][k_SminMin];
            if (TrendMin < 0 && work[r][k_SmaxMin] > work[r-1][k_SmaxMin]) work[r][k_SmaxMin] = work[r-1][k_SmaxMin];
            if (TrendMax > 0 && work[r][k_SminMax] < work[r-1][k_SminMax]) work[r][k_SminMax] = work[r-1][k_SminMax];
            if (TrendMax < 0 && work[r][k_SmaxMax] > work[r-1][k_SmaxMax]) work[r][k_SmaxMax] = work[r-1][k_SmaxMax];
            if (TrendMid > 0 && work[r][k_SminMid] < work[r-1][k_SminMid]) work[r][k_SminMid] = work[r-1][k_SminMid];
            if (TrendMid < 0 && work[r][k_SmaxMid] > work[r-1][k_SmaxMid]) work[r][k_SmaxMid] = work[r-1][k_SmaxMid];

            if (TrendMin > 0) linemin = work[r][k_SminMin] + StepSizeMin;
            if (TrendMin < 0) linemin = work[r][k_SmaxMin] - StepSizeMin;
            if (TrendMax > 0) linemax = work[r][k_SminMax] + StepSizeMax;
            if (TrendMax < 0) linemax = work[r][k_SmaxMax] - StepSizeMax;
            if (TrendMid > 0) linemid = work[r][k_SminMid] + StepSizeMid;
            if (TrendMid < 0) linemid = work[r][k_SmaxMid] - StepSizeMid;

         //
         //
         //
         //
         //
               
         work[r][k_TrendMin] = TrendMin;
         work[r][k_TrendMid] = TrendMid;
         work[r][k_TrendMax] = TrendMax;
         work[r][k_linemin]  = linemin;
         work[r][k_linemid]  = linemid;
         work[r][k_linemax]  = linemax;
            
         //
         //
         //
         //
         //
         
         double bsmin = linemax - StepSizeMax;
         double bsmax = linemax + StepSizeMax;
         if (bsmax!=bsmin)
         {
            stoch1[i] = ((linemin - bsmin) / (bsmax - bsmin)) * 100.0;
            stoch2[i] = ((linemid - bsmin) / (bsmax - bsmin)) * 100.0;
         }
         else               
         {
            stoch1[i] = 0;
            stoch2[i] = 0;
         }
   }
   return(0);
}